"use strict";var N=require("crypto"),_=require("fs"),L=require("path"),O=require("url"),p=require("child_process");require("camelcase");var b=require("slash");require("@svgr/core"),require("dotenv/config");var g=require("@deploysentinel/debugger-core");require("lodash");function d(s){return s&&typeof s=="object"&&"default"in s?s:{default:s}}var q=d(N),c=d(_),u=d(L),P=d(b),y,w;process.env.DEPLOYSENTINEL_API_KEY,(y=process.env.DEPLOYSENTINEL_API_URL)!=null,g.utils.stringToBoolean(process.env.DEPLOYSENTINEL_LOG_VERBOSE),g.utils.stringToBoolean((w=process.env.DEPLOYSENTINEL_REMOTE_DEBUGGING)!=null?w:"1"),g.utils.stringToBoolean(process.env.DEPLOYSENTINEL_UPLOAD_ON_PASSES);const a="./node_modules/.cache/@deploysentinel/jest-rtl-debugger",v="cache-sass-load-paths.config",T=()=>{c.default.existsSync(a)||c.default.mkdirSync(a,{recursive:!0})},$=(s,e)=>{T();const t=u.default.join(a,s);return c.default.writeFileSync(t,e),t},x="\\.(css|less|sass|scss|styl|stylus|pcss|postcss)($|\\?)",F=new RegExp(`\\.module${x}`);function E(s){return/.(sass|scss)$/.test(s)}function C(s){return/.(less)$/.test(s)}function j(s){return E(s)||C(s)}function M(){const s=`const postcssrc = require('postcss-load-config');
  
  postcssrc().then(({ plugins, options }) => {
    console.log(true)
  })
  .catch(error=>{
    if (!/No PostCSS Config found/.test(error.message)) {
      throw new Error("Failed to load PostCSS config", error)
    }
    console.log(false)
  });`;try{const e=h(s),t=p.spawnSync("node",[e]);if(c.default.unlink(e,o=>{if(o)throw o}),t.error)throw t.error;return t.stdout.toString().trim()==="true"}catch{return!1}}function k(s){return P.default(s.split(process.cwd())[1])}const f=s=>({code:`const style = document.createElement('style');
  style.appendChild(document.createTextNode(${JSON.stringify(s)}));
  document.head.appendChild(style);
  module.exports = {}`});function D(s,e){const t=k(e);console.time(`Processing ${t}`);let o=s;const n=F.test(e),i=j(e),r=c.default.existsSync(u.default.join(process.cwd(),"tailwind.config.js"))||c.default.existsSync(u.default.join(process.cwd(),"tailwind.config.cjs")),l=M();return!n&&!i&&!l&&!r?(console.timeEnd(`Processing ${t}`),f(o)):E(e)?f(R(e)):C(e)?f(A(e)):l||r||n?(console.timeEnd(`Processing ${t}`),I(o,e,{useConfigFile:l,isModule:n,haveTailwindCss:r})):(console.timeEnd(`Processing ${t}`),f(o))}function J(s){const e=s.trim().split("---"),t={cssModulesExportedTokens:"",css:""};for(const o of e){const[n,i]=o.trim().split("|||");n==="cssModulesExportedTokens"&&(t.cssModulesExportedTokens=i),n==="css"&&(t.css=i)}return t}function h(s){return $(q.default.randomBytes(16).toString("hex"),s)}function I(s,e,t={useConfigFile:!0,isModule:!1,haveTailwindCss:!1}){var o;const n=`require('postcss-modules')({
    getJSON: (cssFileName, json, outputFileName) => {
      console.log('cssModulesExportedTokens|||', JSON.stringify(json));
      console.log('---')
    },
    // Use custom scoped name to prevent different hash between operating systems
    // Because new line characters can be different between operating systems. Reference: https://stackoverflow.com/a/10805198
    // Original hash function: https://github.com/madyankin/postcss-modules/blob/7d5965d4df201ef301421a5e35805d1b47f3c914/src/generateScopedName.js#L6
    generateScopedName: function (name, filename, css) {
      const stringHash = require('string-hash');
      const i = css.indexOf('.' + name);
      const line = css.substr(0, i).split(/[\\r\\n|\\n|\\r]/).length;
      // This is not how the real app work, might be an issue if we try to make the snapshot interactive
      // https://github.com/nvh95/jest-preview/issues/84#issuecomment-1146578932
      const removedNewLineCharactersCss = css.replace(/(\\r\\n|\\n|\\r)/g, '');
      const hash = stringHash(removedNewLineCharactersCss).toString(36).substr(0, 5);
      return '_' + name + '_' + hash + '_' + line;
    },
  })`;let i=`const postcss = require('postcss');
  const postcssrc = require('postcss-load-config');
  const isModule = ${t.isModule}
  const cssSrc = ${JSON.stringify(s)};
  
  // TODO: We have to re-execute "postcssrc()" every CSS file.
  // Can we do better? Singleton?
  postcssrc().then(({ plugins, options }) => {
    plugins.unshift(require('postcss-import')())
    if (isModule) {
      plugins.push(
        ${n},
      )
    }
    postcss(plugins)
      .process(cssSrc, { ...options, from: ${JSON.stringify(e)} })
      .then((result) => {
        console.log('css|||', result.css);
        console.log('---')
      });
  });`;t.useConfigFile||(i=`const postcss = require('postcss');
const isModule = ${t.isModule};
const haveTailwindCss = ${t.haveTailwindCss};
const cssSrc = ${JSON.stringify(s)};

let plugins = [];
if (isModule) {
  plugins.unshift(require('postcss-import')())
  plugins.push(
    ${n},
  )
}
if (haveTailwindCss) {
  // tailwindCss auto resolve config
  // https://github.com/tailwindlabs/tailwindcss/blob/cef02e2dc395ed5b5d31b72183cf7504b3bd76c1/src/util/resolveConfigPath.js#L45-L52
  plugins.push(require("tailwindcss")())
}
postcss(plugins)
.process(cssSrc, { from: ${JSON.stringify(e)} })
.then((result) => {
  console.log('css|||', result.css);
  console.log('---')
});`);const r=h(i),l=p.spawnSync("node",[r]);if(c.default.unlink(r,S=>{if(S)throw S}),(o=l.stderr)==null||o.toString("utf-8").trim(),l.error)throw l.error;const m=J(l.stdout.toString());return{code:`const style = document.createElement("style");
style.type = "text/css";
const styleContent = ${JSON.stringify(m.css)};
style.appendChild(document.createTextNode(styleContent.replace(/\\\\/g, '')));
document.head.appendChild(style);
module.exports = ${m.cssModulesExportedTokens||"{}"}`}}function R(s){let e;try{e=require("sass")}catch(r){throw console.log(r),new Error("Sass not found. Please install sass and try again.")}const t=u.default.join(a,v);let o;if(c.default.existsSync(t)){const r=c.default.readFileSync(u.default.join(a,v),"utf8").trim();o=JSON.parse(r)}else o=[];let n;const i=r=>r.startsWith("~")?new URL(u.default.join(O.pathToFileURL("node_modules").href,r.substring(1))):null;if(e.compile)n=e.compile(s,{loadPaths:o,importers:[{findFileUrl(r){return i(r)}}]}).css;else if(e.renderSync)n=e.renderSync({file:s,includePaths:o,importer:[function(r){return i(r)}]}).css.toString();else throw new Error("Cannot compile sass to css: No compile method is available.");return n}function A(s){console.log("processLess",s);try{require("less")}catch(n){throw console.log(n),new Error("Less not found. Please install less and try again.")}const e=`const less = require('less');
  const fs = require('fs');
  const path = require('path');
  const cssContent = fs.readFileSync(${JSON.stringify(s)}, 'utf8');
  less.render(cssContent, { filename: ${JSON.stringify(s)}}).then((output) => {
    console.log(output.css);
  });`,t=h(e),o=p.spawnSync("node",[t]);if(c.default.unlink(t,n=>{if(n)throw n}),o.stderr.toString("utf-8").trim(),o.error)throw o.error;return o.stdout.toString()}function B(s,e){return D(s,e)}var U={process:B};module.exports=U;
